#include <iostream>
#include <vector>
using namespace std ;
using ll = long long ;
int main() {
   int n ;
   cin >> n ;
   ll tot = 1 ;
   vector<ll> a(10) ;
   a[0] = 1 ;
   for (int i=0; i<n; i++) {
      vector<ll> na(10) ;
      int lim ;
      cin >> lim ;
      tot *= lim ;
      for (int j=0; j<lim; j++) {
         for (int d=0; d<10; d++)
            if (10 * d + j % 10 < lim && 10 * d + j / 10 < lim)
               na[j % 10] += a[d] ;
      }
      swap(a, na) ;
   }
   for (int d=0; d<10; d++)
      tot -= a[d] ;
   cout << tot << endl ;
}
